%define anolis_release 2

%global _privatelibs libpxbackend-1.0[.]so.*
%global __provides_exclude ^(%{_privatelibs})$
%global __requires_exclude ^(%{_privatelibs})$

Name:           libproxy
Version:        0.5.3
Release:        %{anolis_release}%{?dist}
Summary:        A library that provides automatic proxy configuration management.
License:        LGPLv2+
URL:            https://libproxy.github.io/libproxy/
Source0:        https://github.com/libproxy/libproxy/archive/refs/tags/%{version}.tar.gz

BuildRequires:  gcc meson >= 0.59.0
BuildRequires:  /usr/bin/gi-docgen
BuildRequires:  /usr/bin/vapigen
 
BuildRequires:	pkgconfig(duktape)
BuildRequires:	pkgconfig(gio-2.0) >= 2.71.3
BuildRequires:	pkgconfig(glib-2.0) >= 2.71.3
BuildRequires:	pkgconfig(libcurl)
BuildRequires:  pkgconfig(gobject-introspection-1.0)
# For config-gnome
BuildRequires:  pkgconfig(gsettings-desktop-schemas)
# Folded into main package in 0.5.0.
Provides: python3-%{name} = %{version}-%{release}
Obsoletes: python3-%{name} < %{version}-%{release}
Provides: %{name}-pac = %{version}-%{release}

# Obsoletes of subpackages prior to 0.5.0 rewrite
Provides: %{name}-gnome = %{version}-%{release}
Obsoletes: %{name}-gnome < %{version}-%{release}
Provides: %{name}-kde = %{version}-%{release}
Obsoletes: %{name}-kde < %{version}-%{release}
Provides: %{name}-mozjs = %{version}-%{release}
Obsoletes: %{name}-mozjs < %{version}-%{release}
Provides: %{name}-pacrunner = %{version}-%{release}
Obsoletes: %{name}-pacrunner < %{version}-%{release}
Provides: %{name}-webkitgtk4 = %{version}-%{release}
Obsoletes: %{name}-webkitgtk4 < %{version}-%{release}
Provides: %{name}-networkmanager = %{version}-%{release}
Obsoletes: %{name}-networkmanager < %{version}-%{release}
Provides: %{name}-duktape = %{version}-%{release}
Obsoletes: %{name}-duktape < %{version}-%{release}

%description
libproxy offers the following features:

    * extremely small core footprint
    * minimal dependencies within libproxy core
    * only 4 functions in the stable-ish external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment

%package bin
Summary:        Binary to test %{name}
Requires:       %{name} = %{version}-%{release}

%description bin
The libproxy-bin package contains the proxy binary for libproxy.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
%meson \
  -Dconfig-gnome=true \
  -Dconfig-kde=true \
  -Dconfig-osx=false \
  -Dconfig-windows=false \
  -Dintrospection=true \
  -Dtests=true \
  -Dvapi=true
%meson_build

%install
%meson_install

%check
%meson_test

%files
%license COPYING
%{_libdir}/libproxy.so.*
%dir %{_libdir}/girepository-1.0
%{_libdir}/girepository-1.0/Libproxy-1.0.typelib
%dir %{_libdir}/libproxy
%{_libdir}/libproxy/libpxbackend-1.0.so

%files bin
%{_bindir}/proxy
%{_mandir}/man8/proxy.8*

%files devel
%doc %{_docdir}/libproxy-1.0/
%{_includedir}/libproxy
%{_libdir}/libproxy.so
%{_libdir}/pkgconfig/libproxy-1.0.pc
%dir %{_datadir}/gir-1.0
%{_datadir}/gir-1.0/Libproxy-1.0.gir
%dir %{_datadir}/vala/vapi/
%{_datadir}/vala/vapi/libproxy-1.0.deps
%{_datadir}/vala/vapi/libproxy-1.0.vapi

%files doc
%doc CHANGELOG.md README.md

%changelog
* Tue Mar 12 2024 Bo Ren <rb01097748@alibaba-inc.com> - 0.5.3-2
- Rebuild with python3.11

* Sun Jul 9 2023 Funda Wang <fundawang@yeah.net> - 0.5.3-1
- New version 0.5.3

* Mon Apr 10 2023 chen_yu_ao <m15927509890@163.com> - 0.4.18-3
- change spec file format

* Sun Feb 12 2023 Funda Wang <fundawang@yeah.net> - 0.4.18-2
- Use duktape instead of webkitgtk as js engine

* Wed Sep 21 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.4.18-1
- update to 0.4.18

* Thu Apr 07 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.4.17-1
- Init from upstream version 0.4.17

